#ifndef RandomDistCPP
#define RandomDistCPP

#include "isaac/isaac64.h"
#include "Setup.cpp"

class UniformDist {
	typedef Z T;
	typedef uZ uT;
protected:
	int bits = 0;
	int blocks64 = 0;
	int Tsize = 0;
	T max = 0;
public:
	UniformDist() {};
	UniformDist(T _max) {
		bits = ceil(log2(static_cast<double>(_max)));
		blocks64 = ceil((double)bits / 64);
		Tsize = sizeZ * 8;
		max = _max;
	}
	T get() {
		uT rnd;
		do {
			rnd = irand64();
			for (int i = 1; i < blocks64; i++) {
				uT t = irand64();
				t <<= 64 * i;
				rnd += t;
			}
			rnd <<= Tsize - bits;
			rnd >>= Tsize - bits;
		} while (rnd >= max);
		return rnd;
	}
};

class TernaryDist {
public:
	static int get() {
		uint64_t a = irand64();
		uint8_t b = a & 1, c = (a & 2) >> 1;
		if (b == c) return 0;
		else if (b == 1) return 1;
		else return -1;
	}
};

#endif